SystemOrganization addCategory: #'Parcial<RagaLlorens>'!

Object subclass: #ParcialRagaLlorens
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial<RagaLlorens>'!

!ParcialRagaLlorens methodsFor: 'preguntesTeoria' stamp: 'NatxoRaga 11/4/2012 23:06'!
pregunta2! !

!ParcialRagaLlorens methodsFor: 'preguntesTeoria' stamp: 'NatxoRaga 11/4/2012 23:06'!
pregunta3! !

!ParcialRagaLlorens methodsFor: 'preguntesTeoria' stamp: 'NatxoRaga 11/4/2012 23:06'!
pregunta4! !

OrderedCollection subclass: #Matriu
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial<RagaLlorens>'!

!Matriu class methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/5/2012 23:42'!
identity: aNumber

	| matriu |
	matriu := self new: aNumber.
	
	(1 to: self n) do: [ :row | 
		(1 to: self n) do: [ :col |  row = col ifTrue: [matriu at: (row@col) put: 1]]].
	^ matriu
! !

!Matriu class methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/5/2012 00:56'!
new: aNumber

	| matriu |
	matriu := super new: aNumber * aNumber.
	matriu initialize: aNumber.
	^ matriu! !

!Matriu methodsFor: 'arithmetic' stamp: 'NatxoRaga 11/5/2012 22:48'!
* aFactor
	"Precondition: aFactor must be a matriu or a number"

	| matMult |

	(aFactor class asString = Matriu asString) 
		ifTrue: [(self n = aFactor n) ifFalse: [self error: 'No es poden multiplicar dues matrius de diferent tamany'].
			      matMult := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col |
						(1 to: self n) do: [ :index | matMult at: (row@col) put: (matMult at: row@col) + 
																		         (self at: row@index) + 
																			   (aFactor at: index@col)]]].
				^ matMult]
		ifFalse: [matMult := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matMult at: (row@col) put: (self at: row@col) * aFactor]].
				^ matMult]

	
	
! !

!Matriu methodsFor: 'arithmetic' stamp: 'NatxoRaga 11/5/2012 22:27'!
+ aSumand
	"Precondition: aSumand must be a matriu or a number"

	| matSuma |

	(aSumand class asString = Matriu asString) 
		ifTrue: [(self n = aSumand n) ifFalse: [self error: 'No es poden sumar dues matrius de diferent tamany'].
			      matSuma := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matSuma at: (row@col) put: (self at: row@col) + (aSumand at: row@col)]].
				^ matSuma]
		ifFalse: [matSuma := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matSuma at: (row@col) put: (self at: row@col) + aSumand]].
				^ matSuma]

	
	
! !

!Matriu methodsFor: 'arithmetic' stamp: 'NatxoRaga 11/5/2012 22:04'!
- aSubstrahend
	"Precondition: aSubstrahend must be a matriu or a number"

	| matDiff |

	(aSubstrahend class asString = Matriu asString) 
		ifTrue: [(self n = aSubstrahend n) ifFalse: [self error: 'No es poden restar dues matrius de diferent tamany'].
			      matDiff := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matDiff at: (row@col) put: (self at: row@col) + (aSubstrahend at: row@col)]].
				^ matDiff]
		ifFalse: [matDiff := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matDiff at: (row@col) put: (self at: row@col) + aSubstrahend]].
				^ matDiff]

	
! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/5/2012 21:48'!
at: aPair
	"Precondition: aPair must be of type (x@y), not a normal index."

	^ self at: aPair x at: aPair y! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/5/2012 21:18'!
at: aRow at: aCol

	^ super at: (self indexForRow: aRow andColumn: aCol) ! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/5/2012 01:02'!
at: aRow at: aCol put: aValue

	^ super at: (self indexForRow: aRow andColumn: aCol) put: aValue. ! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/5/2012 21:48'!
at: aPair put: aValue
	"Precondition: aPair must be of type (x@y), not a normal index."

	self at: aPair x at: aPair y put: aValue ! !

!Matriu methodsFor: 'operations' stamp: 'NatxoRaga 11/5/2012 23:45'!
identity

	^ self = (Matriu identity: self n)! !

!Matriu methodsFor: 'private' stamp: 'NatxoRaga 11/5/2012 01:21'!
indexForRow: aRow andColumn: aColumn
	"Return an array index for the specified row and column."
	"Remember that the matrix representation is done with only an array"

	^ (aRow - 1) * self n + aColumn ! !

!Matriu methodsFor: 'initialize-release' stamp: 'NatxoRaga 11/5/2012 01:20'!
initialize: aNumber
	"Initialize all the postions of the Matrix to the number 0"

	self n: aNumber.

	aNumber * aNumber timesRepeat: [self add: 0]

! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/5/2012 00:24'!
n
	
	^ n! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/5/2012 00:24'!
n: aNumber
	
	n := aNumber! !

!Matriu methodsFor: 'printing' stamp: 'NatxoRaga 11/5/2012 21:22'!
printElementsOn: aStream
	"Override the previous function by printing each row on a different line."

	aStream nextPut: Character cr.
	(1 to: self n) do: [ :row | aStream nextPut: $(.
						       (1 to: self n) do: [ :col | aStream print: (self at: row at: col)] separatedBy: [aStream space].
						       aStream nextPut: $).
						       aStream nextPut: Character cr].
	! !

!Matriu methodsFor: 'operations' stamp: 'NatxoRaga 11/5/2012 23:38'!
symmetric

	^ self = self transposed ! !

!Matriu methodsFor: 'operations' stamp: 'NatxoRaga 11/5/2012 23:35'!
transposed

	| matTrans |
	
	(1 to: self n) do: [ :row | 
		(1 to: self n) do: [ :col | matTrans at: (row@col) put: (self at: col@row)]].
	^ matTrans! !
